Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_soa_check.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_soa_check.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_soa_check.f90	(revision 2696)
@@ -0,0 +1,231 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!   Driver to test the Second Order Adjoint (SOA) model
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+PROGRAM KPP_ROOT_Driver
+
+  USE KPP_ROOT_Model
+  USE KPP_ROOT_Initialize, ONLY: Initialize
+
+      KPP_REAL :: T, DVAL(NSPEC), DV(NVAR)
+      KPP_REAL :: ADJ1(NVAR), ADJ2(NVAR)
+      KPP_REAL :: FinalRef(NVAR), FinalRef_tlm(NVAR)
+      KPP_REAL :: FinalPert(NVAR), FinalPert_tlm(NVAR)
+      KPP_REAL :: Hs(NVAR,NVAR), AdjTlm(NVAR,NVAR), SOA(NVAR)
+      INTEGER :: i, j, ind_1 = 1, ind_2 = 2, ind_COST
+      LOGICAL :: LHessian, LAdjTlm
+ 
+!~~~>  Number of second order adjoints
+!      i.e., number of vectors U_i s.t. Sigma_i = Hess*U_i
+!      1 <= i <= NSOA
+
+      INTEGER, PARAMETER :: NSOA = 1
+
+      KPP_REAL :: Y_tlm(NVAR,NSOA)
+      KPP_REAL :: Y_adj(NVAR,1)
+      KPP_REAL :: Y_soa(NVAR,NSOA)
+  
+      STEPMIN = 0.0d0
+      STEPMAX = 0.0d0
+
+      DO i=1,NVAR
+        RTOL(i) = 1.0d-4
+        ATOL(i) = 1.0d-3
+      END DO
+     
+     
+!~~~>  The cost function is 0.5*VAR(ind_COST, tF)**2
+      ind_COST = ind_O3
+     
+     
+!~~~>  Compute the full Hessian NVARxNVAR (or not)
+      LHessian = .TRUE.
+     
+     
+!~~~>  Compute the full Adjoint*Tlm NVARxNVAR (or not)
+      LAdjTlm = .TRUE.
+     
+!~~~~~~~~~~~~~~~~~~~~~~~~
+      PRINT*,'FIRST RUN, Reference'
+      CALL Initialize()
+      DV = 0.0d0
+      DV(ind_NO2) =  0.02*VAR(ind_NO2)
+      DV(ind_NO)  =  0.04*VAR(ind_NO)
+!      DV(ind_PAN) = -0.2*VAR(ind_PAN)
+!      DV(ind_O3)  =  0.1*VAR(ind_O3)
+!      DO i=1,NVAR
+!        DV(i) = rand()*VAR(i)
+!      END DO	
+      Y_tlm(1:NVAR,1) = DV
+      Y_adj(1:NVAR,1) = 0.0d0
+      Y_soa(1:NVAR,1:NSOA) = 0.0d0
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+      FinalRef     = VAR
+      FinalRef_tlm(1:NVAR) = Y_tlm(1:NVAR,1)
+!~~~~~~~~~~~~~~~~~~~~~~~~   
+     
+!~~~~~~~~~~~~~~~~~~~~~~~~
+      PRINT*,'FIRST RUN, Perturbed'
+      CALL Initialize()
+      VAR = VAR + DV
+      Y_tlm(1:NVAR,1) = DV
+      Y_adj(1:NVAR,1) = 0.0d0
+      Y_soa(1:NVAR,1:NSOA) = 0.0d0
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+      FinalPert     = VAR
+      FinalPert_tlm(1:NVAR) = Y_tlm(1:NVAR,1)
+!~~~~~~~~~~~~~~~~~~~~~~~~
+    
+!~~~~~~~~~~~~~~~~~~~~~~~~
+      PRINT*,'PERTURBED RUN'
+      CALL Initialize()
+      VAR = VAR + DV
+      Y_tlm(1:NVAR,1) = DV
+      Y_adj(1:NVAR,1) = 0.0d0
+      Y_adj(ind_COST,1) = FinalPert(ind_COST)
+      Y_soa(1:NVAR,1) = 0.0d0
+      Y_soa(ind_COST,1) = FinalPert_tlm(ind_COST)
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+      F2 = VAR(ind_COST)**2/2
+      ADJ2 = Y_adj(:,1)
+      PRINT*,'PERTURBED FUN = ',F2
+!~~~~~~~~~~~~~~~~~~~~~~~~      
+      
+!~~~~~~~~~~~~~~~~~~~~~~~~
+      PRINT*,'REFERENCE RUN'
+      CALL Initialize()
+      Y_tlm(1:NVAR,1) = DV
+      Y_adj(1:NVAR,1) = 0.0d0
+      Y_adj(ind_COST,1) = FinalRef(ind_COST)
+      Y_soa(1:NVAR,1) = 0.0d0
+      Y_soa(ind_COST,1) = FinalRef_tlm(ind_COST)
+      CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+      F1 = VAR(ind_COST)**2/2
+      ADJ1 = Y_adj(:,1)
+      SOA  = Y_soa(:,1)
+      PRINT*,'REFERENCE FUN = ',F1
+!~~~~~~~~~~~~~~~~~~~~~~~~   
+      
+!~~~~~~~~~~~~~~~~~~~~~~~~
+      IF (LHessian) THEN
+      DO i = 1,NVAR
+        PRINT*,'.... FULL HESSIAN column ',i,' of ',NVAR
+        CALL Initialize()
+        Y_tlm(1:NVAR,1) = 0.0d0
+        Y_tlm(i,1)      = 1.0d0
+        Y_adj(1:NVAR,1) = 0.0d0
+        Y_adj(ind_COST,1) = FinalRef(ind_COST)
+        Y_soa(1:NVAR,1) = 0.0d0
+        Y_soa(ind_COST,1) = FinalRef_tlm(ind_COST)
+        CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+        CALL Initialize()
+        Y_soa(1:NVAR,1) = 0.0d0
+        Y_soa(ind_COST,1) = Y_tlm(ind_COST,1)
+        Y_tlm(1:NVAR,1) = 0.0d0
+        Y_tlm(i,1)      = 1.0d0
+        Y_adj(1:NVAR,1) = 0.0d0
+        Y_adj(ind_COST,1) = FinalRef(ind_COST)
+        CALL INTEGRATE_soa(Nsoa, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+	Hs(1:NVAR,i) = Y_soa(1:NVAR,1)
+      END DO
+      ! Write Hessian in file
+      OPEN(150,FILE='KPP_ROOT_Hess.m')
+      DO i=1,NVAR
+        WRITE(150,224) (Hs(i,j),j=1,NVAR)
+      END DO  
+      CLOSE(150)      
+      END IF
+!~~~~~~~~~~~~~~~~~~~~~~~~
+    
+!~~~~~~~~~~~~~~~~~~~~~~~~
+      IF (LAdjTlm) THEN
+      DO i = 1,NVAR
+        PRINT*,'.... FULL ADJ*TLM column ',i,' of ',NVAR
+        CALL Initialize()
+        Y_tlm(1:NVAR,1) = 0.0d0
+        Y_tlm(i,1)      = 1.0d0
+        Y_adj(1:NVAR,1) = 0.0d0
+        Y_adj(ind_COST,1) = FinalRef(ind_COST)
+        Y_soa(1:NVAR,1) = 0.0d0
+        Y_soa(ind_COST,1) = FinalRef_tlm(ind_COST)
+        CALL INTEGRATE_SOA( NSOA, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+        CALL Initialize()
+        Y_adj(1:NVAR,1) = Y_tlm(1:NVAR)
+        Y_soa(1:NVAR,1) = 0.0d0
+        Y_tlm(1:NVAR,1) = 0.0d0
+        CALL INTEGRATE_soa(Nsoa, VAR, Y_tlm, Y_adj, Y_soa, TSTART, TEND, &
+                            ATOL, RTOL)
+	AdjTlm(1:NVAR,i) = Y_adj(1:NVAR,1)
+      END DO
+      ! Write Hessian in file
+      OPEN(150,FILE='KPP_ROOT_AdjTlm.m')
+      DO i=1,NVAR
+        WRITE(150,224) (AdjTlm(i,j),j=1,NVAR)
+      END DO  
+      CLOSE(150)      
+      END IF
+!~~~~~~~~~~~~~~~~~~~~~~~~
+
+      WRITE(6,*) 'FD versus SOA:'      
+      DO i=1,NVAR
+        WRITE(6,222) ADJ2(i)-ADJ1(i), SOA(i),           &
+	  ABS(ADJ2(i)-ADJ1(i)-SOA(i))/                  &
+          MAX(ABS(ADJ2(i)-ADJ1(i)),ABS(SOA(i)),1.d-16), &
+	  TRIM(SPC_NAMES(i))
+      END DO  
+222   FORMAT('FD=',E12.5,'   soa=',E12.5,'  Diff=',E12.5,'  (',A,')')      
+
+      WRITE(6,FMT="(A14,1X,E14.7)") 'F2-F1 = ',F2-F1
+      WRITE(6,FMT="(A14,1X,E14.7)") 'First = ',DOT_PRODUCT(ADJ1,DV)      
+      WRITE(6,FMT="(A14,1X,E14.7)") 'F2-F1-First = ',F2-F1-DOT_PRODUCT(ADJ1,DV)      
+      WRITE(6,FMT="(A14,1X,E14.7)") 'Second = ',DOT_PRODUCT(SOA,DV)/2      
+
+      IF (LHessian) THEN
+      WRITE(6,*) 'The Hessian:'      
+      DO i=1,NVAR
+        WRITE(6,223) (Hs(i,j),j=1,NVAR)
+      END DO  
+223   FORMAT(100(E12.5,1X))
+      END IF
+
+
+      OPEN(150,FILE='KPP_ROOT_Cost.m')
+      WRITE(150,FMT="(A14,1X,E14.7)") 'F2-F1 = ',F2-F1
+      WRITE(150,FMT="(A14,1X,E14.7)") 'First = ',DOT_PRODUCT(ADJ1,DV)      
+      WRITE(150,FMT="(A14,1X,E14.7)") 'F2-F1-First = ',F2-F1-DOT_PRODUCT(ADJ1,DV)      
+      WRITE(150,FMT="(A14,1X,E14.7)") 'Second = ',DOT_PRODUCT(SOA,DV)/2      
+      CLOSE(150)      
+
+      OPEN(150,FILE='KPP_ROOT_FD.m')
+      DO i=1,NVAR
+        WRITE(150,224) ADJ2(i)-ADJ1(i), SOA(i),        &
+	  ABS(ADJ2(i)-ADJ1(i)-SOA(i))/                 &
+          MAX(ABS(ADJ2(i)-ADJ1(i)),ABS(SOA(i)),1.d-16)
+      END DO  
+      CLOSE(150)      
+
+      OPEN(150,FILE='KPP_ROOT_Sol.m')
+      DO i=1,NVAR
+        WRITE(150,224) FinalRef(i)
+      END DO  
+      CLOSE(150)      
+
+      OPEN(150,FILE='KPP_ROOT_Adj.m')
+      DO i=1,NVAR
+        WRITE(150,224) ADJ1(i)
+      END DO  
+      CLOSE(150)      
+
+224   FORMAT(10000(E24.14,1X))      
+
+
+END PROGRAM KPP_ROOT_Driver
+
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_stochastic.c
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_stochastic.c	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_stochastic.c	(revision 2696)
@@ -0,0 +1,64 @@
+int InitSaveData();
+int SaveData();
+int CloseSaveData();
+int GenerateMatlab( char * prefix );
+void GetMass( double CL[], double Mass[] );
+void INTEGRATE( double TIN, double TOUT );
+void Gillespie(int Nssa, double Volume, double* T, int NmlcV[], int NmlcF[]);
+void Update_RCONST();
+
+/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
+int main()
+/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
+{
+/*~~~> Output results file */
+  FILE* fpDat;
+/*~~~> No of molecules */
+  int NmlcV[NVAR], NmlcF[NFIX];
+/*~~~> No of reaction events per output step */
+  int Nevents;
+/*~~~> Local variables */
+  int i;
+  double T;
+
+  Initialize();  
+      
+  fpDat = fopen("KPP_ROOT_stochastic.dat", "w");
+
+  /* Translate initial values from conc. to molecules */
+  /* Volume = 100.0; */
+  Nevents = 20;
+  for( i = 0; i < NVAR; i++ ) 
+    NmlcV[i] = (int)(Volume*VAR[i]);
+  for( i = 0; i < NFIX; i++ ) 
+    NmlcF[i] = (int)(Volume*FIX[i]);
+  
+/*~~~> Begin Time Loop ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
+  T = TSTART;
+  while (T <= TEND) {
+    printf("\n%6.1f%% %10.4f   ", (T-TSTART)/(TEND-TSTART)*100, T );
+    for( i = 0; i < NVAR; i++ ) 
+      printf( "%s=%d  ", SPC_NAMES[i], NmlcV[i] );
+
+    fprintf(fpDat,"\n%g ", T );
+    for( i = 0; i < NVAR; i++ ) 
+        fprintf(fpDat,"%d  ", NmlcV[i]);
+   
+    Gillespie( Nevents, Volume, &T , NmlcV, NmlcF );
+    
+  }  /* while (T <= TEND) */  
+/*~~~> End Time Loop ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
+
+  fprintf(fpDat,"\n%g ", T );
+  for( i = 0; i < NVAR; i++ ) 
+      fprintf(fpDat,"%d  ", NmlcV[i]);
+  fprintf(fpDat,"\n");
+  fclose(fpDat);
+  
+  printf("\n");
+
+  return 0;
+
+}
+/*~~~> End of MAIN function ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_stochastic.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_stochastic.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_stochastic.f90	(revision 2696)
@@ -0,0 +1,63 @@
+PROGRAM KPP_ROOT_Driver
+
+  USE KPP_ROOT_Model
+  USE KPP_ROOT_Initialize, ONLY: Initialize
+
+  IMPLICIT NONE
+      
+!~~~> No. of Stochastic events per simulation snaphot      
+      INTEGER :: Nevents
+!~~~> No. of Stochastic tau-steps simulation snaphot      
+      INTEGER :: Nsteps
+!~~~> No. of Molecules      
+      INTEGER :: NmlcV(NVAR), NmlcF(NFIX)
+!~~~> Random numbers     
+      REAL :: r1, r2
+!~~~> Local variables     
+      INTEGER :: i
+      KPP_REAL :: T, Tau, SCT(NREACT)
+
+!~~~~> Initialize and prescribe volume and no. of events
+      CALL Initialize()
+      Volume  = 1000.0d0
+      Nevents = 5000
+      Nsteps = 10
+      Tau = (TEND-TSTART)/100.0
+!~~~~~~~~~~~~~~~~     
+      
+!~~~> Translate initial values from conc. to NmlcVules
+      NmlcV(1:NVAR) = INT(Volume*VAR(1:NVAR))
+      NmlcF(1:NFIX) = INT(Volume*FIX(1:NFIX))
+!~~~> Compute the stochastic reaction rates 
+      CALL Update_RCONST()
+      CALL StochasticRates( RCONST, Volume, SCT )   
+
+!~~~> Save initial data
+      OPEN(10, file='KPP_ROOT_stochastic.dat')
+      WRITE(10,992) T, (NmlcV(i),i=1,NVAR)
+            
+!~~~> TIME loop starts
+      T = TSTART
+kron: DO WHILE (T < TEND)
+
+        WRITE(6,991) T,(SPC_NAMES(i),NmlcV(i), i=1,NVAR)
+
+!~~~> Choose here one of the following time-stepping routines
+        CALL Gillespie(Nevents, T, SCT, NmlcV, NmlcF)
+!        CALL TauLeap(Nsteps, Tau, T, SCT, NmlcV, NmlcF)
+        
+        WRITE(10,992) T, (NmlcV(i),i=1,NVAR)
+        
+      END DO kron
+!~~~> TIME loop ends
+
+      WRITE(6,991) T,(SPC_NAMES(i), NmlcV(i), i=1,NVAR)
+
+      CLOSE(10)
+      
+991   FORMAT('T=',F12.3,20(A,'=',I5,'; '))
+992   FORMAT(E24.14,200(1X,I12))
+
+
+END PROGRAM KPP_ROOT_Driver
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_tlm.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_tlm.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/general_tlm.f90	(revision 2696)
@@ -0,0 +1,132 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!   Driver for the tangent linear model (TLM)
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+PROGRAM KPP_ROOT_TLM_Driver
+
+  USE KPP_ROOT_Model
+  USE KPP_ROOT_Initialize, ONLY: Initialize
+
+      KPP_REAL :: T, DVAL(NSPEC)
+      INTEGER :: i, j, ind_1 = 1, ind_2 = 2
+      ! INTEGER :: ind_1 = ind_NO2, ind_2 = ind_O3
+
+!~~~>  NTLM = Number of sensitivity coefficients to compute
+!      Note: this value is set for sensitivities w.r.t. all initial values
+!            the setting may have to be changed for other applications
+      INTEGER, PARAMETER :: NTLM = NVAR
+      KPP_REAL, DIMENSION(NVAR,NTLM) ::  Y_tlm, ATOL_tlm, RTOL_tlm
+
+  
+!~~~>  Control (in) and status (out) vectors for the integrator
+      INTEGER,  DIMENSION(20) :: ICNTRL, ISTATUS
+      KPP_REAL, DIMENSION(20) :: RCNTRL, RSTATUS
+
+      STEPMIN = 0.0d0
+      STEPMAX = 0.0d0
+
+!~~~> Tolerances for calculating concentrations       
+      DO i=1,NVAR
+        RTOL(i) = 1.0d-4
+        ATOL(i) = 1.0d-3
+      END DO
+      
+!~~~> Tolerances for calculating sensitivities 
+!     are used for controlling sensitivity truncation error
+!     and for solving the linear sensitivity equations by iterations  
+!     Note: Sensitivities typically span many orders of magnitude
+!           and a careful tuning of ATOL_tlm may be necessary     
+      DO j=1,NTLM
+        DO i=1,NVAR
+          RTOL_tlm(i,j) = 1.0d-4
+          ATOL_tlm(i,j) = 1.0d-3
+        END DO
+      END DO
+     
+      CALL Initialize()
+!~~~> Note: the initial values below are for sensitivities 
+!           w.r.t. initial values;
+!           they may have to be changed for other applications
+      Y_tlm(1:NVAR,1:NTLM) = 0.0d0
+      DO j=1,NTLM
+        Y_tlm(j,j) = 1.0d0
+      END DO
+
+!~~~> Default control options
+      ICNTRL(1:20) = 0
+      RCNTRL(1:20) = 0.0d0       
+
+!~~~> Begin time loop
+
+      CALL InitSaveData()
+
+      T = TSTART
+      
+kron: DO WHILE (T < TEND)
+       
+        TIME = T
+        CALL GetMass( C, DVAL )
+        WRITE(6,991) (T-TSTART)/(TEND-TSTART)*100, T,      &
+                    (TRIM(SPC_NAMES(MONITOR(i))),          &
+                      C(MONITOR(i))/CFACTOR, i=1,NMONITOR),&
+                    (TRIM(SMASS(i)),DVAL(i)/CFACTOR, i=1,NMASS)
+
+        CALL SaveData()
+        CALL Update_SUN() 
+        CALL Update_RCONST()
+
+        CALL INTEGRATE_TLM( NTLM, VAR, Y_tlm, T, T+DT,     &
+                            ATOL_tlm, RTOL_tlm,            &
+                            ICNTRL, RCNTRL, ISTATUS, RSTATUS )
+
+        T = T+DT
+
+      END DO kron
+
+      CALL GetMass( C, DVAL )
+      WRITE(6,991) (T-TSTART)/(TEND-TSTART)*100, T,        &
+                  (TRIM(SPC_NAMES(MONITOR(i))),            &
+                    C(MONITOR(i))/CFACTOR, i=1,NMONITOR),  &
+                  (TRIM(SMASS(i)),DVAL(i)/CFACTOR, i=1,NMASS)
+
+      CALL SaveData()
+
+!~~~> End time loop ~~~~~~~~~~
+
+      OPEN(20, FILE='KPP_ROOT_TLM_results.m')
+      WRITE(6,*) '**************************************************'
+      WRITE(6,*) ' Concentrations and Sensitivities at final time '
+      WRITE(6,*) ' were written in the file KPP_ROOT_TLM_results.m'
+      WRITE(6,*) '**************************************************'
+      DO j=1,NTLM
+        WRITE(20,993) ( Y_tlm(i,j), i=1,NVAR )          
+      END DO
+
+      CALL CloseSaveData()
+
+      WRITE(6,995) TRIM(SPC_NAMES(ind_1)),TRIM(SPC_NAMES(ind_1)), &
+                   Y_tlm(ind_1,1)
+      WRITE(6,995) TRIM(SPC_NAMES(ind_2)),TRIM(SPC_NAMES(ind_2)), &
+                   Y_tlm(ind_2,2)
+      WRITE(6,995) TRIM(SPC_NAMES(ind_1)),TRIM(SPC_NAMES(ind_2)), &
+                   Y_tlm(ind_2,1)
+      WRITE(6,995) TRIM(SPC_NAMES(ind_2)),TRIM(SPC_NAMES(ind_1)), &
+                   Y_tlm(ind_1,2)
+                  
+                 
+ 991  FORMAT(F6.1,'%. T=',E10.3,3X,20(A,'=',E10.4,';',1X))
+ 993  FORMAT(1000(E24.16,2X))
+ 995  FORMAT('TLM: d[',A,'](tf)/d[',A,'](t0)=',E14.7)
+ 
+ 
+      !~~~> The entire matrix of sensitivities
+      WRITE(6,996) ( 'd ',TRIM(SPC_NAMES(i)), i=1,NVAR ) 
+      DO j=1,NTLM
+        WRITE(6,997) TRIM(SPC_NAMES(j)),( Y_tlm(i,j), i=1,NVAR )          
+      END DO
+ 996  FORMAT(12X,100('  ',A2,A6,4X))
+ 997  FORMAT('d/d',A6,' = ',100(E12.5,2X))
+ 
+
+END PROGRAM KPP_ROOT_TLM_Driver
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/main.c
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/main.c	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/main.c	(revision 2696)
@@ -0,0 +1,52 @@
+void INTEGRATE( double TIN, double TOUT );
+
+void main()
+{
+KPP_REAL rtols;
+KPP_REAL Tstart, Tend, DT;
+FILE * fp;
+int i;
+ 
+/* ---- TIME VARIABLES ------------------ */
+
+  rtols = 1e-3;
+  for( i = 0; i < NVAR; i++ ) {
+    RTOL[i] = rtols;
+    ATOL[i] = 1E-18;
+  }
+     
+  Initialize();
+      
+  fp = fopen("Extrapd.m", "w");
+  fprintf( fp, "ed=[\n");
+       
+  Tstart = 3600*12;
+  Tend = Tstart + 3600*24*5;
+  STEPMIN = 0.001;
+  STEPMAX = 900;
+  DT = 3600.;
+  TEMP = 236.21;
+      
+/* -- BELOW THIS LIMIT USE TAYLOR INSTEAD OF EXP --- */
+/* ********** TIME LOOP **************************** */
+
+  TIME = Tstart;
+  while (TIME <= Tend) {
+
+    printf("\nMonitor: ");
+    for( i = 0; i < NMONITOR; i++ ) 
+      printf( "%12.8g  ", C[ MONITOR[i] ]/CFACTOR );
+
+    fprintf( fp, "\n%6.1f ", (TIME-Tstart)/3600.0 );
+    for( i = 0; i < NLOOKAT; i++ ) 
+      fprintf( fp, "%24.16e ", C[ LOOKAT[i] ]/CFACTOR );
+
+    INTEGRATE( DT );
+  }
+
+/* *********** END TIME LOOP *********************** */
+
+  fprintf(fp, "\n];");
+  fclose( fp );
+  printf("\n");
+}
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/main.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/main.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/drv/main.f	(revision 2696)
@@ -0,0 +1,53 @@
+      PROGRAM driver
+
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Global.h'
+
+      INTEGER i
+  
+C ---- TIME VARIABLES ------------------      
+
+      RTOLS = 1e-3
+      do i=1,NVAR
+        RTOL(i) = RTOLS
+        ATOL(i) = 1E-18
+      end do
+     
+      CALL Initialize()
+      
+      open(10, file='Extrapd.m')
+      write(10,*) 'ed=['
+       
+      TSTART = 3600*12
+      TEND = TSTART + 3600*24*5
+      STEPMIN = 0.01
+      STEPMAX = 900
+      DT = 3600.
+      TEMP = 236.21
+      
+C -- BELOW THIS LIMIT USE TAYLOR INSTEAD OF EXP ---
+C ********** TIME LOOP *************************
+      TIME = TSTART
+      do while (TIME .le. TEND)
+
+        write(6,991) (C(MONITOR(i))/CFACTOR, i=1,NMONITOR)
+
+        write(10,992) (TIME-TSTART)/3600.D0, 
+     *                (C(LOOKAT(i))/CFACTOR, i=1,NLOOKAT)
+
+        call Update_SUN() 
+        call Update_RCONST()
+
+        call INTEGRATE( TIME, TIME+DT )
+
+      end do
+C *********** END TIME LOOP ********
+
+      write(10,*) '];'
+      close(10)
+      STOP
+
+991   FORMAT('Monitor:',10(1X,E12.6))
+992   FORMAT(F6.1,100(1X,D24.16))
+      END
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/MCM/mcm_constants.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/MCM/mcm_constants.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/examples/MCM/mcm_constants.f90	(revision 2696)
@@ -0,0 +1,350 @@
+MODULE constants
+
+  USE model_Precision, ONLY: dp
+  IMPLICIT NONE
+  PRIVATE dp
+
+  INTEGER, PARAMETER :: mnsp=250, mre=2000
+  INTEGER i
+  ! variables for zenith routine which calculates zenith angle
+  REAL(dp) theta, secx, cosx
+  ! generic reaction rate variables
+  REAL(dp) kro2no, kro2ho2, kapho2, kapno, kro2no3, kno3al, kdec, &
+    krosec, kalkoxy, kalkpxy, kroprim
+  ! variables for calculation of kfpan and kbpan
+  REAL(dp) kfpan, kbpan
+  REAL(dp) kc0, kci, krc, fcc, nc, fc
+  REAL(dp) kd0, kdi, krd, fcd, ncd, fd
+  ! variables for calculation of kmt01
+  REAL(dp) kmt01
+  REAL(dp) k10, k1i, kr1, fc1, nc1, f1
+  ! variables for calculation of kmt02
+  REAL(dp) kmt02
+  REAL(dp) k20, k2i, kr2, fc2, nc2, f2
+  ! variables for calculation of kmt03
+  REAL(dp) kmt03
+  REAL(dp) k30, k3i, kr3, fc3, nc3, f3
+  ! variables for calculation of kmt04
+  REAL(dp) kmt04
+  REAL(dp) k40, k4i, kr4, fc4, nc4, f4
+  ! variables for calculation of kmt05
+  REAL(dp) kmt05
+  ! variables for calculation of kmt06
+  REAL(dp) kmt06
+  ! variables for calculation of kmt07
+  REAL(dp) kmt07
+  REAL(dp) k70, k7i, kr7, fc7, nc7, f7
+  ! variables for calculation of kmt08
+  REAL(dp) kmt08
+  REAL(dp) k80, k8i, kr8, fc8, nc8, f8
+  ! variables for calculation of kmt09
+  REAL(dp) kmt09
+  REAL(dp) k90, k9i, kr9, fc9, nc9, f9
+  ! variables for calculation of kmt10
+  REAL(dp) kmt10
+  REAL(dp) k100, k10i, kr10, fc10, nc10, f10
+  ! variables for calculation of kmt11
+  REAL(dp) kmt11
+  REAL(dp) k1,k2,k3,k4
+  ! variables for calculation of kmt12
+  REAL(dp) kmt12
+  REAL(dp) k0, ki, x, ssign,f
+  REAL(dp) k120, k12i, kr12, fc12, nc12, f12
+  ! variables for calculation of kmt13
+  REAL(dp) kmt13
+  REAL(dp) k130, k13i, kr13, nc13, fc13, f13
+  ! variables for calculation of kmt14
+  REAL(dp) kmt14
+  REAL(dp) k140, k14i, kr14, nc14, fc14, f14
+  ! variables for calculation of kmt15
+  REAL(dp) kmt15
+  REAL(dp) k150, k15i, kr15, fc15, nc15, f15
+  ! variables for calculation of kmt16
+  REAL(dp) kmt16
+  REAL(dp) k160, k16i, kr16, nc16, fc16, f16
+  ! variables for calculation of kmt17
+  REAL(dp) kmt17
+  REAL(dp) k170, k17i, kr17, fc17, nc17, f17
+  ! variables for calculation of kmt17
+  REAL(dp) kmt18
+
+  REAL(dp) kch3o2, k298ch3o2
+  
+  REAL(dp) kp_rooh, kp_ho2, kp_n2o5, kp_no3, kp_all
+  
+  INTEGER k
+
+CONTAINS
+
+  !***************************************************************************
+
+  SUBROUTINE mcm_constants(time, temp, M, N2, O2, RO2, H2O)
+    ! calculates rate constants from arrhenius informtion
+    USE model_Global,  ONLY:LAT, LON, JDAY, SZAS, SVJ_TJ, bs,cs,ds, jfactno2, jfacto1d, &
+         DEP_ROOH, DEP_HO2, DEP_N2O5, DEP_NO3, DEP_ALL
+    REAL(dp) time, temp, M, N2, O2, RO2, H2O, THETA, TIME2, LAT2
+    REAL*8 y,dy,x,tmp(19), tmp2(19),b(19),c(19),d(19)
+    integer i,n,jl
+    INTEGER LK
+
+ 
+    ! ************************************************************************
+    ! define generic reaction rates.
+    ! ************************************************************************
+
+    ! constants used in calculation of reaction rates
+    !M  = 2.55E+19
+    N2 = 0.79*M
+    O2 = 0.2095*M
+
+    kp_rooh = DEP_ROOH
+    kp_ho2  = DEP_HO2
+    kp_n2o5 = DEP_N2O5
+    kp_no3  = DEP_NO3
+    kp_all  = DEP_ALL
+
+
+    ! kro2no : ro2      + no      = ro      + no2
+    !        : ro2      + no      = rono2
+    ! mcm v3.2
+    !kro2no    = 2.7d-12*EXP(360.0/temp)
+
+    ! kro2ho2: ro2      + ho2     = rooh    + o2
+    ! mcm protocol v3.2
+    !kro2ho2   = 2.91d-13*EXP(1300.0/temp)
+
+    ! kapho2 : rcoo2    + ho2     = products
+    ! mcm protocol v3.2
+    !kapho2    = 5.20d-13*EXP(980.0/temp)
+
+    ! kapno  : rcoo2    + no      = products
+    ! mcm v3.2
+    !kapno = 7.50d-12*EXP(290.0/temp)
+
+    ! kro2no3: ro2      + no3     = products
+    ! mcm protocol v3.2
+    !kro2no3   = 2.30d-12
+
+    ! kno3al : no3      + rcho    = rcoo2   + hno3
+    ! mcm protocol v3.2
+    !kno3al    = 1.4d-12*EXP(-1860.0/temp)
+
+    ! kdec   : ro                 = products
+    ! mcm protocol v3.2
+    !kdec      = 1.00d+06
+    
+    kalkoxy=6.00d-14*EXP(-550.0/temp)*o2
+    kalkpxy=1.50d-14*EXP(-200.0/temp)*o2
+
+    !kch3o2 = 1.03d-13*EXP(365.0/TEMP)
+    !k298ch3o2 = 3.5d-13
+
+    ! -------------------------------------------------------------------
+    ! complex reactions
+    ! -------------------------------------------------------------------
+
+    ! kfpan kbpan
+    ! formation and decomposition of pan
+    ! iupac 2001 (mcmv3.2)
+    kc0     = 2.70d-28*m*(temp/300.0)**(-7.1)
+    kci     = 1.21d-11*(temp/300.0)**(-0.9)
+    krc     = kc0/kci
+    fcc     = 0.30
+    nc      = 0.75-(1.27*dlog10(fcc))
+    fc      = 10**(dlog10(fcc)/(1+((dlog10(krc))/nc)**2))
+    kfpan   = (kc0*kci)*fc/(kc0+kci)
+
+    kd0     = 4.90d-03*m*EXP(-12100.0/temp)
+    kdi     = 5.40d+16*EXP(-13830.0/temp)
+    krd     = kd0/kdi
+    fcd     = 0.30
+    ncd     = 0.75-(1.27*dlog10(fcd))
+    fd      = 10**(dlog10(fcd)/(1+((dlog10(krd))/ncd)**2))
+    kbpan   = (kd0*kdi)*fd/(kd0+kdi)
+
+    ! kmt01  : o        + no      = no2
+    ! iupac 2001 (mcmv3.2)
+    k10     = 1.00d-31*m*(temp/300.0)**(-1.6)
+
+    k1i     = 3.00d-11*(temp/300.0)**(0.3)
+    kr1     = k10/k1i
+    fc1     = 0.85
+    nc1     = 0.75-(1.27*dlog10(fc1))
+    f1      = 10**(dlog10(fc1)/(1+((dlog10(kr1)/nc1))**2))
+    kmt01   = (k10*k1i)*f1/(k10+k1i)
+
+    ! kmt02  : o        + no2     = no3
+    ! iupac 2001 (mcmv3.2)
+    k20     = 1.30d-31*m*(temp/300.0)**(-1.5)
+    k2i     = 2.30d-11*(temp/300.0)**(0.24)
+    kr2     = k20/k2i
+    fc2     = 0.6
+    nc2     = 0.75-(1.27*dlog10(fc2))
+    f2      = 10**(dlog10(fc2)/(1+((dlog10(kr2)/nc2))**2))
+    kmt02   = (k20*k2i)*f2/(k20+k2i)
+
+    ! kmt03  : no2      + no3     = n2o5
+    ! iupac 2006, mcmv3.2
+    k30     = 3.60d-30*m*(temp/300.0)**(-4.1)
+    k3i     = 1.90d-12*(temp/300.0)**(0.2)
+    kr3     = k30/k3i
+    fc3     = 0.35
+    nc3     = 0.75-(1.27*dlog10(fc3))
+    f3      = 10**(dlog10(fc3)/(1+((dlog10(kr3)/nc3))**2))
+    kmt03   = (k30*k3i)*f3/(k30+k3i)
+
+    ! kmt04  : n2o5               = no2     + no3
+    ! iupac 2006, mcmv3.2
+    k40     = 1.30d-03*m*(temp/300.0)**(-3.5)*EXP(-11000.0/temp)
+    k4i     = 9.70d+14*(temp/300.0)**(0.1)*EXP(-11080.0/temp)
+    kr4     = k40/k4i
+    fc4     = 0.35
+    nc4     = 0.75-(1.27*dlog10(fc4))
+    f4      = 10**(dlog10(fc4)/(1+((dlog10(kr4)/nc4))**2))
+    kmt04   = (k40*k4i)*f4/(k40+k4i)
+
+    ! kmt05  : oh       + co(+o2) = ho2     + co2
+    ! iupac 2006
+    kmt05  = (1 + (m/4.2d19))
+
+    ! kmt06  : ho2      + ho2     = h2o2    + o2
+    ! water enhancement factor
+    ! iupac 1992
+
+    kmt06  = 1 + (1.40d-21*EXP(2200.0/temp)*h2o)
+
+    ! kmt06  = 1 + (2.00d-25*EXP(4670.0/temp)*h2o)
+    ! S+R 2005 values
+
+    ! kmt07  : oh       + no      = hono
+
+    ! iupac 2006, mcmv3.2
+    k70     = 7.40d-31*m*(temp/300.0)**(-2.4)
+    k7i     = 3.30d-11*(temp/300.0)**(-0.3)
+    kr7     = k70/k7i
+    fc7     = EXP(-temp/1420.0)
+    nc7     = 0.75-(1.27*dlog10(fc7))
+    f7      = 10**(dlog10(fc7)/(1+((dlog10(kr7)/nc7))**2))
+    kmt07   = (k70*k7i)*f7/(k70+k7i)
+
+    ! kmt08  : oh       + no2     = hno3
+
+    ! iupac 2006, mcmv3.2
+    k80     = 3.30d-30*m*(temp/300.0)**(-3.0)
+    k8i     = 4.10d-11
+    kr8     = k80/k8i
+    fc8     = 0.4
+    nc8     = 0.75-(1.27*dlog10(fc8))
+    f8      = 10**(dlog10(fc8)/(1+((dlog10(kr8)/nc8))**2))
+    kmt08   = (k80*k8i)*f8/(k80+k8i)
+
+    ! kmt09  : ho2      + no2     = ho2no2
+    ! iupac 1997, mcmv3.2
+
+    k90     = 1.80d-31*m*(temp/300.0)**(-3.2)
+    k9i     = 4.70d-12
+    kr9     = k90/k9i
+    fc9     = 0.6
+    nc9     = 0.75-(1.27*dlog10(fc9))
+    f9      = 10**(dlog10(fc9)/(1+((dlog10(kr9)/nc9))**2))
+    kmt09   = (k90*k9i)*f9/(k90+k9i)
+
+    ! kmt10  : ho2no2             = ho2     + no2
+    ! iupac 1997, mcmv3.2
+
+    k100     = 4.10d-05*m*EXP(-10650.0/temp)
+    k10i     = 4.80d+15*EXP(-11170.0/temp)
+    kr10     = k100/k10i
+    fc10     = 0.6
+    nc10     = 0.75-(1.27*dlog10(fc10))
+    f10      = 10**(dlog10(fc10)/(1+((dlog10(kr10)/nc10))**2))
+    kmt10    = (k100*k10i)*f10/(k100+k10i)
+
+    ! kmt11  : oh       + hno3    = h2o     + no3
+    ! iupac 2006, mcmv3.2
+
+    k1     = 2.40d-14*EXP(460.0/temp)
+    k3     = 6.50d-34*EXP(1335.0/temp)
+    k4     = 2.70d-17*EXP(2199.0/temp)
+    k2     = (k3*m)/(1+(k3*m/k4))
+    kmt11  = k1 + k2
+
+    ! kmt12 iupac 2006, mcmv3.2
+
+    k120 = 4.50d-31*((temp/300.0)**(-3.9))*m
+    k12i = 1.30d-12*((temp/300.0)**(-0.7))
+    kr12 = k120/k12i
+    fc12 = 0.525
+    nc12 = 0.75-(1.27*dlog10(fc12))
+    f12  = 10**(dlog10(fc12)/(1.+((dlog10(kr12)/nc12))**2))
+    kmt12    = (k120*k12i)*f12/(k120+k12i)
+
+    ! kmt13  : ch3o2    + no2     = ch3o2no2
+    ! iupac 2006
+
+    k130     = 2.50d-30*((temp/300.0)**(-5.5))*m
+    k13i     = 1.80d-11
+    kr13     = k130/k13i
+    fc13     = 0.36
+    nc13     = 0.75-(1.27*dlog10(fc13))
+    f13      = 10**(dlog10(fc13)/(1+((dlog10(kr13)/nc13))**2))
+    kmt13    = (k130*k13i)*f13/(k130+k13i)
+
+    ! kmt14  : ch3o2no2           = ch3o2   + no2
+    ! iupac 2006, mcmv3.2
+
+    k140     = 9.00d-05*EXP(-9690.0/temp)*m
+    k14i     = 1.10d+16*EXP(-10560.0/temp)
+    kr14     = k140/k14i
+    fc14     = 0.4
+    nc14     = 0.75-(1.27*dlog10(fc14))
+    f14      = 10**(dlog10(fc14)/(1+((dlog10(kr14)/nc14))**2))
+    kmt14    = (k140*k14i)*f14/(k140+k14i)
+
+    ! kmt15 iupac 2006, mcmv3.2
+
+    k150 = 8.60d-29*((temp/300.0)**(-3.1))*m
+    k15i = 9.00d-12*((temp/300.0)**(-0.85))
+    kr15 = k150/k15i
+    fc15 = 0.48
+    nc15 = 0.75-(1.27*dlog10(fc15))
+    f15  = 10**(dlog10(fc15)/(1+((dlog10(kr15)/nc15))**2))
+    kmt15 = (k150*k15i)*f15/(k150+k15i)
+
+    ! kmt16  :  oh  +  c3h6
+    ! iupac 2006
+
+    k160     = 8.00d-27*((temp/300.0)**(-3.5))*m
+    k16i     = 3.00d-11*((temp/300.0)**(-1.0))
+    kr16     = k160/k16i
+    fc16     = 0.5
+    nc16     = 0.75-(1.27*dlog10(fc16))
+    f16      = 10**(dlog10(fc16)/(1+((dlog10(kr16)/nc16))**2))
+    kmt16    = (k160*k16i)*f16/(k160+k16i)
+
+    ! kmt17 iupac 2006
+
+    k170 = 5.00d-30*((temp/300.0)**(-1.5))*m
+    k17i = 1.00d-12
+    kr17 = k170/k17i
+    fc17 = (0.17*EXP(-51./temp))+EXP(-temp/204.)
+    nc17 = 0.75-(1.27*dlog10(fc17))
+    f17  = 10**(dlog10(fc17)/(1+((dlog10(kr17)/nc17))**2))
+    kmt17 = (k170*k17i)*f17/(k170+k17i)
+
+    ! kmt18 2011 oh + dms
+
+    !kmt18=(9.5d-39*O2*EXP(5270./TEMP))/(1+7.5d-29*O2*exp(5610./TEMP))
+
+    !       mcm v3.2
+
+    !kroprim  = 2.50d-14*EXP(-300.0/temp)
+    !krosec   = 2.50d-14*EXP(-300.0/temp)
+
+  
+  END SUBROUTINE mcm_constants
+
+  !***************************************************************************
+
+      
+END MODULE constants
